import { JsonDB, Config } from "node-json-db";
import { Knex } from "knex";
import knex from "knex";

export abstract class JSONDatabase {
    protected readonly rawDB: JsonDB;
    protected isLoaded: boolean = false;
    constructor(file: string) {
        this.rawDB = new JsonDB(new Config(file, false, true, "/"));
        return new Proxy(this, {
            get(target, name, reciever) {
                if (
                    target.isLoaded ||
                    !(name in Object.getOwnPropertyNames(target))
                ) {
                    return target[name];
                } else {
                    throw new Error("Database is not loaded");
                }
            },
            set(target, name, newValue, reciever) {
                if (target.isLoaded || name == "isLoaded") {
                    target[name] = newValue;
                } else {
                    return false;
                }
                return true;
            },
        });
    }
    async load() {
        this.isLoaded = true;
        await this.rawDB.load();
    }
}

export abstract class SQLDatabase {
    protected readonly rawDB: Knex<any, unknown[]>;
    constructor(file: string) {
        this.rawDB = knex({
            client: "better-sqlite3",
            connection: {
                filename: file,
            },
        });
    }
}