import { IFaucetMail } from "../../interfaces/IFaucetMail";
import { JSONDatabase } from "../ADatabase";

export class JSONFaucetMails extends JSONDatabase {
    async getWallets(): Promise<IFaucetMail[]> {
        const rawWallets = await this.rawDB.getData("/");
        const wallets: IFaucetMail[] = [];
        for (const rawWallet of Object.keys(rawWallets)) {
            try {
                const wallet: IFaucetMail = {
                    faucet: {
                        username: rawWallets[rawWallet].faucetpay.username,
                        password: rawWallets[rawWallet].faucetpay.password,
                    },
                    mail: {
                        address: rawWallet,
                        password: rawWallets[rawWallet].mail_passphrase,
                    },
                };
                wallets.push(wallet);
            } catch (e) {
                continue;
            }
        }
        return wallets;
    }
}