import { Fingerprint } from "fingerprint-generator";
import { IFaucetMail } from "./IFaucetMail";
import { IWorkerWithdraw } from "./IWithdraw";

export interface IWorkerCompletedGroupTask {
    readonly timeToLeave: number;
    readonly groupID: string;
}

interface IWorkerBase {
    readonly phoneNumber: string;
    readonly telegramID: number;
    readonly apiID: number;
    readonly apiHash: string;
    readonly password: string;
    readonly stringSession: string;
    readonly balance: number;
    readonly canBeRefferal: boolean;
    
    readonly refferal: number | null;
}

export interface IWorkerDatabase extends IWorkerBase {
    readonly faucetMail: string;
    readonly browserFingerprint: string;
    troubled: boolean
}

export interface IWorker extends IWorkerBase{

    readonly faucetMail: IFaucetMail;
    readonly browserFingerprint: Fingerprint;
    withdraws: IWorkerWithdraw[];
    completedGroupsTasks: IWorkerCompletedGroupTask[];
    troubled: boolean
}